## rustc 1.24.1%2Bdfsg1%2Bllvm

=== src/llvm/lib/CMakeLists.txt ===
# `Demangle', `Support' and `TableGen' libraries are added on the top-level
# CMakeLists.txt

add_subdirectory(IR)
add_subdirectory(IRReader)
add_subdirectory(CodeGen)
add_subdirectory(Bitcode)
add_subdirectory(Transforms)
add_subdirectory(Linker)
add_subdirectory(Analysis)
add_subdirectory(LTO)
add_subdirectory(MC)
add_subdirectory(Object)
add_subdirectory(ObjectYAML)
add_subdirectory(Option)
add_subdirectory(DebugInfo)
add_subdirectory(ExecutionEngine)
add_subdirectory(Target)
add_subdirectory(AsmParser)
add_subdirectory(LineEditor)
add_subdirectory(ProfileData)
add_subdirectory(Fuzzer)
add_subdirectory(Passes)
add_subdirectory(LibDriver)
add_subdirectory(XRay)

=== src/llvm/projects/CMakeLists.txt ===
# Discover the projects that use CMake in the subdirectories.
# Note that explicit cmake invocation is required every time a new project is
# added or removed.
file(GLOB entries *)
foreach(entry ${entries})
  if(IS_DIRECTORY ${entry} AND EXISTS ${entry}/CMakeLists.txt)
    if((NOT ${entry} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR}/compiler-rt) AND
       (NOT ${entry} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR}/dragonegg) AND
       (NOT ${entry} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR}/libcxx) AND
       (NOT ${entry} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR}/libcxxabi) AND
       (NOT ${entry} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR}/libunwind) AND
       (NOT ${entry} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR}/test-suite) AND
       (NOT ${entry} STREQUAL ${CMAKE_CURRENT_SOURCE_DIR}/parallel-libs))
      add_subdirectory(${entry})
    endif()
  endif()
endforeach(entry)

# Also add in libc++ and compiler-rt trees if present (and we have
# a sufficiently recent version of CMake where required).
if(${LLVM_BUILD_RUNTIME})
  # MSVC isn't quite working with libc++ yet, disable it until issues are
  # fixed.
  if(NOT MSVC)
    # Add the projects in reverse order of their dependencies so that the
    # dependent projects can see the target names of their dependencies.
    add_llvm_external_project(libunwind)
    add_llvm_external_project(libcxxabi)
    add_llvm_external_project(libcxx)
  endif()
  if(NOT LLVM_BUILD_EXTERNAL_COMPILER_RT)
    add_llvm_external_project(compiler-rt)
  endif()
endif()

add_llvm_external_project(dragonegg)
add_llvm_external_project(parallel-libs)

=== src/llvm/tools/bugpoint-passes/CMakeLists.txt ===
if( NOT LLVM_BUILD_TOOLS )
  set(EXCLUDE_FROM_ALL ON)
endif()

# If we don't need RTTI or EH, there's no reason to export anything
# from this plugin.
if( NOT LLVM_REQUIRES_RTTI )
  if( NOT LLVM_REQUIRES_EH )
    set(LLVM_EXPORTED_SYMBOL_FILE ${CMAKE_CURRENT_SOURCE_DIR}/bugpoint.exports)
  endif()
endif()

if(WIN32 OR CYGWIN)
  set(LLVM_LINK_COMPONENTS Core)
endif()

add_llvm_loadable_module( BugpointPasses
  TestPasses.cpp

  DEPENDS
  intrinsics_gen
  bugpoint
  )

=== src/llvm/tools/llvm-lto2/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  ${LLVM_TARGETS_TO_BUILD}
  Core
  Linker
  LTO
  MC
  Object
  Support
  Target
  )

add_llvm_tool(llvm-lto2
  llvm-lto2.cpp

  DEPENDS
  intrinsics_gen
  )

=== src/llvm/tools/opt/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  ${LLVM_TARGETS_TO_BUILD}
  Analysis
  BitWriter
  CodeGen
  Core
  Coroutines
  IPO
  IRReader
  Linker
  # @LOCALMOD-BEGIN
  JSBackend
  # @LOCALMOD-END
  InstCombine
  Instrumentation
  MC
  ObjCARCOpts
  ScalarOpts
  Support
  Target
  TransformUtils
  Vectorize
  Passes
  )

# Support plugins.
set(LLVM_NO_DEAD_STRIP 1)

add_llvm_tool(opt
  AnalysisWrappers.cpp
  BreakpointPrinter.cpp
  GraphPrinters.cpp
  NewPMDriver.cpp
  PassPrinters.cpp
  PrintSCC.cpp
  opt.cpp

  DEPENDS
  intrinsics_gen
  )
export_executable_symbols(opt)

if(WITH_POLLY AND LINK_POLLY_INTO_TOOLS)
  target_link_libraries(opt Polly)
endif(WITH_POLLY AND LINK_POLLY_INTO_TOOLS)

=== src/llvm/unittests/Support/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  Support
  )

add_llvm_unittest(SupportTests
  AlignOfTest.cpp
  AllocatorTest.cpp
  ArrayRecyclerTest.cpp
  BlockFrequencyTest.cpp
  BranchProbabilityTest.cpp
  Casting.cpp
  Chrono.cpp
  CommandLineTest.cpp
  CompressionTest.cpp
  ConvertUTFTest.cpp
  DataExtractorTest.cpp
  DebugTest.cpp
  DwarfTest.cpp
  EndianStreamTest.cpp
  EndianTest.cpp
  ErrorOrTest.cpp
  ErrorTest.cpp
  FileOutputBufferTest.cpp
  FormatVariadicTest.cpp
  GlobPatternTest.cpp
  Host.cpp
  LEB128Test.cpp
  LineIteratorTest.cpp
  LockFileManagerTest.cpp
  MD5Test.cpp
  ManagedStatic.cpp
  MathExtrasTest.cpp
  MemoryBufferTest.cpp
  MemoryTest.cpp
  NativeFormatTests.cpp
  Path.cpp
  ProcessTest.cpp
  ProgramTest.cpp
  RegexTest.cpp
  ReplaceFileTest.cpp
  ScaledNumberTest.cpp
  SourceMgrTest.cpp
  SpecialCaseListTest.cpp
  StringPool.cpp
  SwapByteOrderTest.cpp
  TarWriterTest.cpp
  TargetParserTest.cpp
  ThreadLocalTest.cpp
  ThreadPool.cpp
  Threading.cpp
  TimerTest.cpp
  TypeNameTest.cpp
  TrailingObjectsTest.cpp
  TrigramIndexTest.cpp
  UnicodeTest.cpp
  YAMLIOTest.cpp
  YAMLParserTest.cpp
  formatted_raw_ostream_test.cpp
  raw_ostream_test.cpp
  raw_pwrite_stream_test.cpp
  raw_sha1_ostream_test.cpp
  xxhashTest.cpp
  )

# ManagedStatic.cpp uses <pthread>.
target_link_libraries(SupportTests ${LLVM_PTHREAD_LIB})

=== src/test/run-make/issue-28766/Makefile ===
-include ../tools.mk

all:
	$(RUSTC) -O foo.rs
	$(RUSTC) -O -L $(TMPDIR) main.rs

=== src/test/run-make/lto-no-link-whole-rlib/Makefile ===
# Copyright 2016 The Rust Project Developers. See the COPYRIGHT
# file at the top-level directory of this distribution and at
# http://rust-lang.org/COPYRIGHT.
#
# Licensed under the Apache License, Version 2.0 <LICENSE-APACHE or
# http://www.apache.org/licenses/LICENSE-2.0> or the MIT license
# <LICENSE-MIT or http://opensource.org/licenses/MIT>, at your
# option. This file may not be copied, modified, or distributed
# except according to those terms.

-include ../tools.mk

all: $(call NATIVE_STATICLIB,foo) $(call NATIVE_STATICLIB,bar)
	$(RUSTC) lib1.rs
	$(RUSTC) lib2.rs
	$(RUSTC) main.rs -Clto
	$(call RUN,main)

=== src/test/run-make/multiple-emits/Makefile ===
-include ../tools.mk

all:
	$(RUSTC) foo.rs --emit=asm,llvm-ir -o $(TMPDIR)/out 2>&1
	rm $(TMPDIR)/out.ll $(TMPDIR)/out.s
	$(RUSTC) foo.rs --emit=asm,llvm-ir -o $(TMPDIR)/out2.ext 2>&1
	rm $(TMPDIR)/out2.ll $(TMPDIR)/out2.s

=== src/test/run-make/output-filename-overwrites-input/Makefile ===
-include ../tools.mk

all:
	cp foo.rs $(TMPDIR)/foo
	$(RUSTC) $(TMPDIR)/foo 2>&1 \
		| $(CGREP) -e "the input file \".*foo\" would be overwritten by the generated executable"
	$(RUSTC) foo.rs 2>&1 && $(RUSTC) -Z ls $(TMPDIR)/foo 2>&1
	cp foo.rs $(TMPDIR)/foo.rs
	$(RUSTC) $(TMPDIR)/foo.rs -o $(TMPDIR)/foo.rs 2>&1 \
		| $(CGREP) -e "the input file \".*foo.rs\" would be overwritten by the generated executable"

=== src/test/run-make/stable-symbol-names/Makefile ===
-include ../tools.mk

# The following command will:
#  1. dump the symbols of a library using `nm`
#  2. extract only those lines that we are interested in via `grep`
#  3. from those lines, extract just the symbol name via `sed`
#     (symbol names always start with "_ZN" and end with "E")
#  4. sort those symbol names for deterministic comparison
#  5. write the result into a file

dump-symbols = nm "$(TMPDIR)/lib$(1).rlib" \
             | grep -E "$(2)" \
             | sed "s/.*\(_ZN.*E\).*/\1/" \
             | sort \
             > "$(TMPDIR)/$(1)$(3).nm"

# This test
# - compiles each of the two crates 2 times and makes sure each time we get
#   exactly the same symbol names
# - makes sure that both crates agree on the same symbol names for monomorphic
#   functions

all:
	$(RUSTC) stable-symbol-names1.rs
	$(call dump-symbols,stable_symbol_names1,generic_|mono_,_v1)
	rm $(TMPDIR)/libstable_symbol_names1.rlib
	$(RUSTC) stable-symbol-names1.rs
	$(call dump-symbols,stable_symbol_names1,generic_|mono_,_v2)
	cmp "$(TMPDIR)/stable_symbol_names1_v1.nm" "$(TMPDIR)/stable_symbol_names1_v2.nm"

	$(RUSTC) stable-symbol-names2.rs
	$(call dump-symbols,stable_symbol_names2,generic_|mono_,_v1)
	rm $(TMPDIR)/libstable_symbol_names2.rlib
	$(RUSTC) stable-symbol-names2.rs
	$(call dump-symbols,stable_symbol_names2,generic_|mono_,_v2)
	cmp "$(TMPDIR)/stable_symbol_names2_v1.nm" "$(TMPDIR)/stable_symbol_names2_v2.nm"

	$(call dump-symbols,stable_symbol_names1,mono_,_cross)
	$(call dump-symbols,stable_symbol_names2,mono_,_cross)
	cmp "$(TMPDIR)/stable_symbol_names1_cross.nm" "$(TMPDIR)/stable_symbol_names2_cross.nm"

=== src/test/run-make/type-mismatch-same-crate-name/Makefile ===
-include ../tools.mk

all:
	# compile two different versions of crateA
	$(RUSTC) --crate-type=rlib crateA.rs -C metadata=-1 -C extra-filename=-1
	$(RUSTC) --crate-type=rlib crateA.rs -C metadata=-2 -C extra-filename=-2
	# make crateB depend on version 1 of crateA
	$(RUSTC) --crate-type=rlib crateB.rs --extern crateA=$(TMPDIR)/libcrateA-1.rlib
	# make crateC depend on version 2 of crateA
	$(RUSTC) crateC.rs --extern crateA=$(TMPDIR)/libcrateA-2.rlib 2>&1 | \
		tr -d '\r\n' | $(CGREP) -e \
	"mismatched types.*\
	crateB::try_foo\(foo2\);.*\
	expected struct \`crateA::foo::Foo\`, found struct \`crateA::Foo\`.*\
	different versions of crate \`crateA\`.*\
	mismatched types.*\
	crateB::try_bar\(bar2\);.*\
	expected trait \`crateA::bar::Bar\`, found trait \`crateA::Bar\`.*\
	different versions of crate \`crateA\`"

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc:native .*,/p}" debian/control

include /usr/share/dpkg/buildflags.mk
# TODO: more correct to use `[build] rustflags = []` list syntax in Cargo.toml
RUSTFLAGS = $(addprefix -C link-args=,$(LDFLAGS))
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS RUSTFLAGS
# set remap-path-prefix for reproducible builds; TODO: remove "if" after 1.20
ifeq (0,$(shell dpkg --compare-versions "$$(rustc --version --verbose | sed -ne 's/^release: //p')" '>=' 1.19.0; echo $$?))
RUSTFLAGS += -Zremap-path-prefix-from=$(CURDIR) -Zremap-path-prefix-to=/usr/src/rustc-$(RUST_LONG_VERSION)
export RUSTC_BOOTSTRAP = 1
endif

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
export DEB_HOST_RUST_TYPE

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# src/rt/miniz.c (incorrectly) triggers -Wmisleading-indentation with
# gcc-6.  See bug #811573.
CFLAGS += -Wno-misleading-indentation

# Enable large file support in LLVM for 32-bit architectures
ifeq (32,$(DEB_HOST_ARCH_BITS))
CFLAGS += -D_FILE_OFFSET_BITS=64
CXXFLAGS += -D_FILE_OFFSET_BITS=64
endif

# Release type (one of beta, stable or nightly)
RELEASE_CHANNEL := stable
# See also ./build-preview-dsc.sh for a script that builds a beta/nightly .dsc
# out of this packaging. Furthermore, if the build breaks after importing a new
# upstream stable release, check the do_temporary_fixup function in that file
# to see if we already know what fix to make.

DEB_DESTDIR := $(CURDIR)/debian/tmp

RUSTBUILD = RUST_BACKTRACE=1 ./x.py
RUSTBUILD_FLAGS = --config debian/config.toml -v --on-fail env
# TODO: This should simply be "$(RUSTBUILD) test" but unfortunately this causes
# an insane blow up in the time it takes to run tests. See upstream #37477 for
# details. Upstream worked around it in #38984 but in Debian we can't take
# advantage of that work-around, because we want as much debuginfo as possible
# (so we set debuginfo-lines = true, debuginfo-only-std = false) so we have to
# work around it instead by disabling backtrace when running tests.
RUSTBUILD_TEST = ./x.py test
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	if [ $$oldver != $$newver ]; then debian/update-version.sh $$oldver $$newver; fi

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
DOWNLOAD_BOOTSTRAP := false
ENABLE_LOCAL_RUST := 0
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        ENABLE_LOCAL_RUST := 1
        # Make it easier to test against a custom rustc
        ifneq (,$(RUST_DESTDIR))
        RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
        export LD_LIBRARY_PATH
        endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
    else
        DOWNLOAD_BOOTSTRAP := true
    endif
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS := true
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  BUILD_DOCS := false
endif

MAKE_OPTIMISATIONS := true
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  MAKE_OPTIMISATIONS := false
endif

BUILD_DEBUGINFO := true
ifeq (32,$(DEB_BUILD_ARCH_BITS))
# Building with no debuginfo seems to be the only way to get a
# successful build on 32-bit build machines
  BUILD_DEBUGINFO := false
endif

# Build products or non-source files in src/, that shouldn't go in rust-src
SRC_CLEAN = src/rt/hoedown/src/html_blocks.c \
	src/bootstrap/bootstrap.pyc \
	src/etc/__pycache__/

# Workaround for linux #865549
ifeq (0,$(shell test $$(uname -s) = "Linux" -a $$(getconf PAGESIZE) -gt 4096; echo $$?))
  SYSTEM_WORKAROUNDS += ulimit -s $$(expr $$(getconf PAGESIZE) / 1024 '*' 256 + 8192);
endif

%:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

.PHONY: build
build:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

override_dh_clean:
	# Upstream contains a lot of these
	dh_clean -XCargo.toml.orig

debian/config.toml: debian/config.toml.in
	m4  -DDEB_BUILD_RUST_TYPE="$(DEB_BUILD_RUST_TYPE)" \
		-DDEB_HOST_RUST_TYPE="$(DEB_HOST_RUST_TYPE)" \
		-DDEB_TARGET_RUST_TYPE="$(DEB_TARGET_RUST_TYPE)" \
		-DRELEASE_CHANNEL="$(RELEASE_CHANNEL)" \
		-DBUILD_DOCS="$(BUILD_DOCS)" \
		-DMAKE_OPTIMISATIONS="$(MAKE_OPTIMISATIONS)" \
		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
		-DBUILD_DEBUGINFO="$(BUILD_DEBUGINFO)" \
		-DENABLE_LOCAL_RUST="$(ENABLE_LOCAL_RUST)" \
		"$<" > "$@"
	! $(DOWNLOAD_BOOTSTRAP) || sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"
	# Work around armhf issue: https://github.com/rust-lang/rust/issues/45854
	[ $(DEB_BUILD_ARCH) != armhf -a \
	  $(DEB_BUILD_ARCH) != armel ] || sed -i -e '/^debuginfo-only-std = /d' "$@"

debian/rust-src.%: debian/rust-src.%.in
	m4  -DRUST_LONG_VERSION="$(RUST_LONG_VERSION)" \
		"$<" > "$@"

override_dh_auto_configure: debian/config.toml
	$(PRECONFIGURE_CHECK)
	if [ -d stage0 ]; then mkdir -p build && ln -sfT ../stage0 build/cache; fi
	# work around #842634
	if test $$(grep "127.0.0.1\s*localhost" /etc/hosts | wc -l) -gt 1; then \
	  debian/ensure-patch -N debian/patches/d-host-duplicates.patch; fi
	# We patched mdbook so have to rm the checksums
	debian/prune-checksums src/vendor/mdbook/.cargo-checksum.json
	# Unfortunately upstream uses a duplicate copy of libbacktrace and wants to
	# compile it again for rust-installer, see #43449
	ln -rsf src/libbacktrace -t src/vendor/backtrace-sys/src/

## rustc 1.24.1+dfsg1

=== src/rt/hoedown/Makefile ===
CFLAGS = -g -O3 -ansi -pedantic -Wall -Wextra -Wno-unused-parameter
PREFIX = /usr/local
BINDIR = $(PREFIX)/bin
LIBDIR = $(PREFIX)/lib
INCLUDEDIR = $(PREFIX)/include

HOEDOWN_CFLAGS = $(CFLAGS) -Isrc
ifneq ($(OS),Windows_NT)
	HOEDOWN_CFLAGS += -fPIC
endif

SONAME = -soname
ifeq ($(shell uname -s),Darwin)
	SONAME = -install_name
endif

HOEDOWN_SRC=\
	src/autolink.o \
	src/buffer.o \
	src/document.o \
	src/escape.o \
	src/html.o \
	src/html_blocks.o \
	src/html_smartypants.o \
	src/stack.o \
	src/version.o

.PHONY:		all test test-pl clean

all:		libhoedown.so libhoedown.a hoedown smartypants

# Libraries

libhoedown.so: libhoedown.so.3
	ln -f -s $^ $@

libhoedown.so.3: $(HOEDOWN_SRC)
	$(CC) -Wl,$(SONAME),$(@F) -shared $^ $(LDFLAGS) -o $@

libhoedown.a: $(HOEDOWN_SRC)
	$(AR) rcs libhoedown.a $^

# Executables

hoedown: bin/hoedown.o $(HOEDOWN_SRC)
	$(CC) $^ $(LDFLAGS) -o $@

smartypants: bin/smartypants.o $(HOEDOWN_SRC)
	$(CC) $^ $(LDFLAGS) -o $@

# Perfect hashing

src/html_blocks.c: html_block_names.gperf
	gperf -L ANSI-C -N hoedown_find_block_tag -c -C -E -S 1 --ignore-case -m100 $^ > $@

# Testing

test: hoedown libhoedown.a
	$(CC) test/line.c libhoedown.a -o test/tester
	python test/runner.py

test-pl: hoedown
	perl test/MarkdownTest_1.0.3/MarkdownTest.pl \
		--script=./hoedown --testdir=test/MarkdownTest_1.0.3/Tests --tidy

# Housekeeping

clean:
	$(RM) src/*.o bin/*.o
	$(RM) libhoedown.so libhoedown.so.1 libhoedown.a
	$(RM) hoedown smartypants hoedown.exe smartypants.exe

# Installing

install:
	install -m755 -d $(DESTDIR)$(LIBDIR)
	install -m755 -d $(DESTDIR)$(BINDIR)
	install -m755 -d $(DESTDIR)$(INCLUDEDIR)

	install -m644 libhoedown.a $(DESTDIR)$(LIBDIR)
	install -m755 libhoedown.so.3 $(DESTDIR)$(LIBDIR)
	ln -f -s libhoedown.so.3 $(DESTDIR)$(LIBDIR)/libhoedown.so

	install -m755 hoedown $(DESTDIR)$(BINDIR)
	install -m755 smartypants $(DESTDIR)$(BINDIR)

	install -m755 -d $(DESTDIR)$(INCLUDEDIR)/hoedown
	install -m644 src/*.h $(DESTDIR)$(INCLUDEDIR)/hoedown

# Generic object compilations

%.o: %.c
	$(CC) $(HOEDOWN_CFLAGS) -c -o $@ $<

src/html_blocks.o: src/html_blocks.c
	$(CC) $(HOEDOWN_CFLAGS) -Wno-static-in-inline -c -o $@ $<

=== src/test/run-make/atomic-lock-free/Makefile ===
-include ../tools.mk

# This tests ensure that atomic types are never lowered into runtime library calls that are not
# guaranteed to be lock-free.

all:
ifeq ($(UNAME),Linux)
ifeq ($(filter x86,$(LLVM_COMPONENTS)),x86)
	$(RUSTC) --target=i686-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
	$(RUSTC) --target=x86_64-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
endif
ifeq ($(filter arm,$(LLVM_COMPONENTS)),arm)
	$(RUSTC) --target=arm-unknown-linux-gnueabi atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
	$(RUSTC) --target=arm-unknown-linux-gnueabihf atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
	$(RUSTC) --target=armv7-unknown-linux-gnueabihf atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
endif
ifeq ($(filter aarch64,$(LLVM_COMPONENTS)),aarch64)
	$(RUSTC) --target=aarch64-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
endif
ifeq ($(filter mips,$(LLVM_COMPONENTS)),mips)
	$(RUSTC) --target=mips-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
	$(RUSTC) --target=mipsel-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
endif
ifeq ($(filter powerpc,$(LLVM_COMPONENTS)),powerpc)
	$(RUSTC) --target=powerpc-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
	$(RUSTC) --target=powerpc64-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
	$(RUSTC) --target=powerpc64le-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
	$(RUSTC) --target=s390x-unknown-linux-gnu atomic_lock_free.rs
	nm "$(TMPDIR)/libatomic_lock_free.rlib" | $(CGREP) -v __atomic_fetch_add
endif
endif

=== src/test/run-make/intrinsic-unreachable/Makefile ===
-include ../tools.mk

ifndef IS_WINDOWS
# The assembly for exit-unreachable.rs should be shorter because it's missing
# (at minimum) a return instruction.

all:
	$(RUSTC) -O --emit asm exit-ret.rs
	$(RUSTC) -O --emit asm exit-unreachable.rs
	test `wc -l < $(TMPDIR)/exit-unreachable.s` -lt `wc -l < $(TMPDIR)/exit-ret.s`
else
# Because of Windows exception handling, the code is not necessarily any shorter.
# https://github.com/llvm-mirror/llvm/commit/64b2297786f7fd6f5fa24cdd4db0298fbf211466
all:
endif

=== src/test/run-make/no-builtins-lto/Makefile ===
-include ../tools.mk

all:
	# Compile a `#![no_builtins]` rlib crate
	$(RUSTC) no_builtins.rs
	# Build an executable that depends on that crate using LTO. The no_builtins crate doesn't
	# participate in LTO, so its rlib must be explicitly linked into the final binary. Verify this by
	# grepping the linker arguments.
	$(RUSTC) main.rs -C lto -Z print-link-args | $(CGREP) 'libno_builtins.rlib'

=== src/test/run-make/sanitizer-dylib-link/Makefile ===
-include ../tools.mk

LOG := $(TMPDIR)/log.txt

# This test builds a shared object, then an executable that links it as a native
# rust library (constrast to an rlib). The shared library and executable both
# are compiled with address sanitizer, and we assert that a fault in the dylib
# is correctly detected.

ifeq ($(TARGET),x86_64-unknown-linux-gnu)
ASAN_SUPPORT=$(SANITIZER_SUPPORT)

# See comment in sanitizer-address/Makefile for why this is here
EXTRA_RUSTFLAG=-C relocation-model=dynamic-no-pic
endif

all:
ifeq ($(ASAN_SUPPORT),1)
	$(RUSTC) -g -Z sanitizer=address --crate-type dylib --target $(TARGET) $(EXTRA_RUSTFLAG) library.rs
	$(RUSTC) -g -Z sanitizer=address --crate-type bin --target $(TARGET) $(EXTRA_RUSTFLAG) -llibrary program.rs
	LD_LIBRARY_PATH=$(TMPDIR) $(TMPDIR)/program 2>&1 | $(CGREP) stack-buffer-overflow
endif

=== src/test/run-make/sanitizer-staticlib-link/Makefile ===
-include ../tools.mk

# This test builds a staticlib, then an executable that links to it.
# The staticlib and executable both  are compiled with address sanitizer, 
# and we assert that a fault in the staticlib is correctly detected.

ifeq ($(TARGET),x86_64-unknown-linux-gnu)
ASAN_SUPPORT=$(SANITIZER_SUPPORT)
EXTRA_RUSTFLAG=
endif

all:
ifeq ($(ASAN_SUPPORT),1)
	$(RUSTC) -g -Z sanitizer=address --crate-type staticlib --target $(TARGET) library.rs
	$(CC) program.c $(call STATICLIB,library) $(call OUT_EXE,program) $(EXTRACFLAGS) $(EXTRACXXFLAGS)
	LD_LIBRARY_PATH=$(TMPDIR) $(TMPDIR)/program 2>&1 | $(CGREP) stack-buffer-overflow
endif

=== src/test/run-make/symbols-are-reasonable/Makefile ===
-include ../tools.mk

# check that the compile generated symbols for strings, binaries,
# vtables, etc. have semisane names (e.g. `str.1234`); it's relatively
# easy to accidentally modify the compiler internals to make them
# become things like `str"str"(1234)`.

OUT=$(TMPDIR)/lib.s

all:
	$(RUSTC) lib.rs --emit=asm --crate-type=staticlib
	# just check for symbol declarations with the names we're expecting.
	$(CGREP) -e 'str\.[0-9]+:' 'byte_str\.[0-9]+:' 'vtable\.[0-9]+' < $(OUT)

=== src/libcompiler_builtins/compiler-rt/lib/lsan/CMakeLists.txt ===
include_directories(..)

set(LSAN_CFLAGS ${SANITIZER_COMMON_CFLAGS})
append_rtti_flag(OFF LSAN_CFLAGS)

set(LSAN_COMMON_SOURCES
  lsan_common.cc
  lsan_common_linux.cc)

set(LSAN_SOURCES
  lsan.cc
  lsan_allocator.cc
  lsan_interceptors.cc
  lsan_preinit.cc
  lsan_thread.cc)

set(LSAN_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR})

add_compiler_rt_object_libraries(RTLSanCommon
    OS ${SANITIZER_COMMON_SUPPORTED_OS}
    ARCHS ${LSAN_COMMON_SUPPORTED_ARCH}
    SOURCES ${LSAN_COMMON_SOURCES}
    CFLAGS ${LSAN_CFLAGS})

if(COMPILER_RT_HAS_LSAN)
  add_compiler_rt_component(lsan)
  foreach(arch ${LSAN_SUPPORTED_ARCH})
    add_compiler_rt_runtime(clang_rt.lsan
      STATIC
      ARCHS ${arch}
      SOURCES ${LSAN_SOURCES}
              $<TARGET_OBJECTS:RTInterception.${arch}>
              $<TARGET_OBJECTS:RTSanitizerCommon.${arch}>
              $<TARGET_OBJECTS:RTSanitizerCommonLibc.${arch}>
              $<TARGET_OBJECTS:RTLSanCommon.${arch}>
      CFLAGS ${LSAN_CFLAGS}
      PARENT_TARGET lsan)
  endforeach()
endif()

=== src/libcompiler_builtins/compiler-rt/test/tsan/CMakeLists.txt ===
set(TSAN_TEST_DEPS ${SANITIZER_COMMON_LIT_TEST_DEPS})
if(${COMPILER_RT_DEFAULT_TARGET_ARCH} MATCHES "x86_64")
  list(APPEND TSAN_TEST_DEPS GotsanRuntimeCheck)
endif()
if(NOT COMPILER_RT_STANDALONE_BUILD)
  list(APPEND TSAN_TEST_DEPS tsan)
endif()
if(COMPILER_RT_HAS_LIBCXX_SOURCES AND
   COMPILER_RT_TEST_COMPILER_ID STREQUAL "Clang"
   AND NOT APPLE)
  list(APPEND TSAN_TEST_DEPS libcxx_tsan)
  set(TSAN_HAS_LIBCXX True)
else()
  set(TSAN_HAS_LIBCXX False)
endif()

set(TSAN_TESTSUITES)

set(TSAN_TEST_ARCH ${TSAN_SUPPORTED_ARCH})
if(APPLE)
  darwin_filter_host_archs(TSAN_SUPPORTED_ARCH TSAN_TEST_ARCH)
endif()

foreach(arch ${TSAN_TEST_ARCH})
  set(TSAN_TEST_TARGET_ARCH ${arch})
  string(TOLOWER "-${arch}" TSAN_TEST_CONFIG_SUFFIX)
  get_test_cc_for_arch(${arch} TSAN_TEST_TARGET_CC TSAN_TEST_TARGET_CFLAGS)

  string(TOUPPER ${arch} ARCH_UPPER_CASE)
  set(CONFIG_NAME ${ARCH_UPPER_CASE}Config)

  configure_lit_site_cfg(
    ${CMAKE_CURRENT_SOURCE_DIR}/lit.site.cfg.in
    ${CMAKE_CURRENT_BINARY_DIR}/${CONFIG_NAME}/lit.site.cfg)
  list(APPEND TSAN_TESTSUITES ${CMAKE_CURRENT_BINARY_DIR}/${CONFIG_NAME})
endforeach()

if(COMPILER_RT_INCLUDE_TESTS)
  configure_lit_site_cfg(
    ${CMAKE_CURRENT_SOURCE_DIR}/Unit/lit.site.cfg.in
    ${CMAKE_CURRENT_BINARY_DIR}/Unit/lit.site.cfg)
  list(APPEND TSAN_TEST_DEPS TsanUnitTests)
  list(APPEND TSAN_TESTSUITES ${CMAKE_CURRENT_BINARY_DIR}/Unit)
endif()

add_lit_testsuite(check-tsan "Running ThreadSanitizer tests"
  ${TSAN_TESTSUITES}
  DEPENDS ${TSAN_TEST_DEPS})
set_target_properties(check-tsan PROPERTIES FOLDER "Compiler-RT Tests")

=== debian/changelog ===
rustc (1.24.1+dfsg1-1~deb9u2+rpi1) stretch-staging; urgency=medium

  [changes brought forward from 1.15.1+dfsg1-1~exp3+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Wed, 15 Mar 2017 10:16:18 +0000]
  * Build for armv6.
  [changes introduced in 1.18.0+dfsg1-4+rpi1 by Peter Michael Green]
  * Disable testsuite.
  [changes introduced in 1.24.1+dfsg1-1+rpi1 by Peter Michael Green]
  * Remove -march=native from src/binaryen/CMakeLists.txt

 -- Peter Michael Green <plugwash@raspbian.org>  Thu, 16 Aug 2018 12:03:30 +0000

rustc (1.24.1+dfsg1-1~deb9u2) stretch; urgency=medium

  * Add Build-Depends on rustc [!amd64] to prevent buildds from attempting
    further builds, further supported architectures need to be cross-compiled
    (Closes: #903118)

 -- Moritz Mühlenhoff <jmm@debian.org>  Sun, 08 Jul 2018 21:39:35 +0200

rustc (1.24.1+dfsg1-1~deb9u1) stretch; urgency=medium

  * Build for stretch to be used by Firefox ESR60
  * Enable stage0 build
  * Disable -doc package, requires packages not found in stretch and
    docs are available online anyway

 -- Moritz Mühlenhoff <jmm@debian.org>  Sun, 01 Jul 2018 13:42:52 +0200

rustc (1.24.1+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.
  * Raise allowed-test-failures to 160 on some non-release arches: powerpc,
    powerpcspe, sparc64, x32.

 -- Ximin Luo <infinity0@debian.org>  Wed, 07 Mar 2018 20:07:27 +0100

rustc (1.24.1+dfsg1-1~exp2) experimental; urgency=medium

  * Steal some patches from Fedora to fix some test failures.
  * Update debian/patches/u-make-tests-work-without-rpath.patch to try to fix
    some more test failures.

 -- Ximin Luo <infinity0@debian.org>  Mon, 05 Mar 2018 16:25:26 +0100

rustc (1.24.1+dfsg1-1~exp1) experimental; urgency=medium

  * More sparc64 CABI fixes. (Closes: #888757)
  * New upstream release.
  * Note that s390x baseline was updated in the meantime. (Closes: #851150)
  * Include Debian-specific patch to disable kernel helpers on armel.
    (Closes: #891902)
  * Include missing build-dependencies for pkg.rustc.dlstage0 build profile.
    (Closes: #891022)
  * Add architecture.mk mapping for armel => armv5te-unknown-linux-gnueabi.
    (Closes: #891913)
  * Enable debuginfo-only-std on armel as well. (Closes: #891961)
  * Backport upstream patch to support powerpcspe. (Closes: #891542)
  * Disable full-bootstrap again to work around upstream #48319.

 -- Ximin Luo <infinity0@debian.org>  Sat, 03 Mar 2018 14:23:29 +0100

rustc (1.23.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Ximin Luo <infinity0@debian.org>  Fri, 19 Jan 2018 11:49:31 +0100

rustc (1.23.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update to latest Standards-Version; no changes required.

 -- Ximin Luo <infinity0@debian.org>  Sun, 14 Jan 2018 00:08:17 +0100

rustc (1.22.1+dfsg1-2) unstable; urgency=medium

  * Fix B-D rustc version so this package can be built using itself.

 -- Ximin Luo <infinity0@debian.org>  Mon, 01 Jan 2018 14:27:19 +0100

rustc (1.22.1+dfsg1-1) unstable; urgency=medium

  [ Ximin Luo ]
  * Remove unimportant files that autoload remote resources from rust-src.
  * Fix more symlinks in rust-doc.
  * On armhf, only generate debuginfo for libstd and not the compiler itself.
    This works around buildds running out of memory, see upstream #45854.
  * Update to latest Standards-Version; no changes required.

  [ Chris Coulson ]
  * Fix some test failures that occur because we build rust without an rpath.

 -- Ximin Luo <infinity0@debian.org>  Mon, 18 Dec 2017 19:46:25 +0100

=== debian/control ===
Source: rustc
Section: devel
Priority: optional
Maintainer: Rust Maintainers <pkg-rust-maintainers@lists.alioth.debian.org>
Uploaders: Jordan Justen <jordan.l.justen@intel.com>,
 Luca Bruno <lucab@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>,
 Angus Lees <gus@debian.org>,
 Ximin Luo <infinity0@debian.org>
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.17.14),
               python:native,
               llvm-4.0-dev:native   (>= 1:4.0.1-8),
               llvm-4.0-tools:native (>= 1:4.0.1-8),
               libllvm4.0            (>= 1:4.0.1-8),
               autotools-dev,
               cmake (>= 3.0) | cmake3,
               gperf,
               rustc [!amd64],
# this is sometimes needed by rustc_llvm
               zlib1g-dev:native,
               zlib1g-dev,
# used by rust-installer
               liblzma-dev:native,
# test dependencies:
               binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
               git <!nocheck>,
               procps <!nocheck>,
# below are optional tools even for 'make check'
               gdb (>= 7.12) <!nocheck>,
# Work around #864741. The version constraint for gdb above should already do
# that, but this will keep things covered even in the case that they change
# gdb-minimal to do a versioned Provides: gdb.
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
               curl <pkg.rustc.dlstage0>,
               ca-certificates <pkg.rustc.dlstage0>,
Build-Conflicts: gdb-minimal <!nocheck>
Standards-Version: 4.1.3
Homepage: http://www.rust-lang.org/
Vcs-Git: https://anonscm.debian.org/git/pkg-rust/rust.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-rust/rust.git

Package: rustc
Architecture: any
Multi-Arch: allowed
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
 gcc, libc-dev, binutils (>= 2.26)
Recommends: rust-gdb | rust-lldb
Suggests: rust-src
Description: Rust systems programming language
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.

Package: libstd-rust-1.24
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Rust standard libraries
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries, built as dylibs.

Package: libstd-rust-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libstd-rust-1.24 (= ${binary:Version})
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains development files necessary to use the standard
 Rust libraries.

Package: rust-gdb
Architecture: all
Depends: gdb, ${misc:Depends}
Suggests: gdb-doc
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (gdb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking gdb on rust binaries.

Package: rust-lldb
Architecture: all
# When updating, also update rust-lldb.links
Depends: lldb-4.0, ${misc:Depends}, python-lldb-4.0
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (lldb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking lldb on rust binaries.

Package: rust-src
Architecture: all
Depends: ${misc:Depends}
Description: Rust systems programming language - source code
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains sources of the Rust compiler and standard
 libraries, useful for IDEs and code analysis tools such as Racer.

=== debian/rules ===
--- 
+++ 
@@ -32,12 +32,6 @@
 # gcc-6.  See bug #811573.
 CFLAGS += -Wno-misleading-indentation
 
-# Enable large file support in LLVM for 32-bit architectures
-ifeq (32,$(DEB_HOST_ARCH_BITS))
-CFLAGS += -D_FILE_OFFSET_BITS=64
-CXXFLAGS += -D_FILE_OFFSET_BITS=64
-endif
-
 # Release type (one of beta, stable or nightly)
 RELEASE_CHANNEL := stable
 # See also ./build-preview-dsc.sh for a script that builds a beta/nightly .dsc
@@ -46,6 +40,16 @@
 # to see if we already know what fix to make.
 
 DEB_DESTDIR := $(CURDIR)/debian/tmp
+
+# Use system LLVM (comment out to use vendored LLVM)
+LLVM_VERSION = 4.0
+OLD_LLVM_VERSION = 3.9
+# Make it easier to test against a custom LLVM
+ifneq (,$(LLVM_DESTDIR))
+LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
+LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
+export LD_LIBRARY_PATH
+endif
 
 RUSTBUILD = RUST_BACKTRACE=1 ./x.py
 RUSTBUILD_FLAGS = --config debian/config.toml -v --on-fail env
@@ -73,7 +77,6 @@
 PRECONFIGURE_CHECK = :
 HAVE_BINARY_TARBALL := $(shell ls -1 stage0/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
 DOWNLOAD_BOOTSTRAP := false
-ENABLE_LOCAL_RUST := 0
 # allow not using the binary tarball although it exists
 #ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
 #  HAVE_BINARY_TARBALL := 0
@@ -87,7 +90,6 @@
     # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
     # In this case, we use the distro's rustc - either the previous or current version.
     ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
-        ENABLE_LOCAL_RUST := 1
         # Make it easier to test against a custom rustc
         ifneq (,$(RUST_DESTDIR))
         RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
@@ -127,13 +129,6 @@
   MAKE_OPTIMISATIONS := false
 endif
 
-BUILD_DEBUGINFO := true
-ifeq (32,$(DEB_BUILD_ARCH_BITS))
-# Building with no debuginfo seems to be the only way to get a
-# successful build on 32-bit build machines
-  BUILD_DEBUGINFO := false
-endif
-
 # Build products or non-source files in src/, that shouldn't go in rust-src
 SRC_CLEAN = src/rt/hoedown/src/html_blocks.c \
 	src/bootstrap/bootstrap.pyc \
@@ -162,11 +157,12 @@
 		-DRELEASE_CHANNEL="$(RELEASE_CHANNEL)" \
 		-DBUILD_DOCS="$(BUILD_DOCS)" \
 		-DMAKE_OPTIMISATIONS="$(MAKE_OPTIMISATIONS)" \
+		-DLLVM_DESTDIR="$(LLVM_DESTDIR)" \
+		-DLLVM_VERSION="$(LLVM_VERSION)" \
 		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
-		-DBUILD_DEBUGINFO="$(BUILD_DEBUGINFO)" \
-		-DENABLE_LOCAL_RUST="$(ENABLE_LOCAL_RUST)" \
 		"$<" > "$@"
-	! $(DOWNLOAD_BOOTSTRAP) || sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"
+	if $(DOWNLOAD_BOOTSTRAP) || [ $(HAVE_BINARY_TARBALL) != 0 ]; \
+	  then sed -i -e '/^rustc = /d' -e '/^cargo = /d' "$@"; fi
 	# Work around armhf issue: https://github.com/rust-lang/rust/issues/45854
 	[ $(DEB_BUILD_ARCH) != armhf -a \
 	  $(DEB_BUILD_ARCH) != armel ] || sed -i -e '/^debuginfo-only-std = /d' "$@"
@@ -176,13 +172,11 @@
 		"$<" > "$@"
 
 override_dh_auto_configure: debian/config.toml
+	# fail the build if we have any instances of OLD_LLVM_VERSION in debian, except for debian/changelog
+	! grep --color=always -i 'll...\?$(subst .,\.,$(OLD_LLVM_VERSION))' --exclude=changelog -R debian
 	$(PRECONFIGURE_CHECK)
 	if [ -d stage0 ]; then mkdir -p build && ln -sfT ../stage0 build/cache; fi
 	# work around #842634
 	if test $$(grep "127.0.0.1\s*localhost" /etc/hosts | wc -l) -gt 1; then \
 	  debian/ensure-patch -N debian/patches/d-host-duplicates.patch; fi
 	# We patched mdbook so have to rm the checksums
-	debian/prune-checksums src/vendor/mdbook/.cargo-checksum.json
-	# Unfortunately upstream uses a duplicate copy of libbacktrace and wants to
-	# compile it again for rust-installer, see #43449
-	ln -rsf src/libbacktrace -t src/vendor/backtrace-sys/src/
